SystemOrganization addCategory: #'Glamour-Morphic-Pager'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Announcement'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Exception'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Glamour'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Model'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Morphic'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Tests'!

Morph subclass: #GLMPagerBarMorph
	instanceVariableNames: 'buttons scrollBar adapter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 23:56'!
adapter: anAdapter
	
	adapter := anAdapter.
	
	adapter announcer weak
		on: GLMPagePushed send: #onPagePushed: to: self.
		
	adapter announcer weak
		on: GLMPagePoped send: #onPagePoped to: self.
	
	self addButtons.
	self addScrollBar.! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/29/2014 00:28'!
addButtons
	buttons ifNil: [
		buttons := adapter isDependenciesShown ifTrue: [ GLMPagerPaneDependencyButtonsMorph new ] ifFalse: [ GLMPagerPaneButtonsMorph new ].
		buttons adapter: adapter.
		self addMorph: buttons fullFrame: (0@0 extent: 1@1).
	]
	! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/25/2014 17:58'!
addScrollBar
	scrollBar ifNil: [
		scrollBar := GLMSlidingScrollMorph new.
		scrollBar adapter: adapter.
		"scrollBar height: self height."
		scrollBar height: adapter circleButtonSize.
		
		self addMorph: scrollBar fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 0 @ 0)
					offsets: (0 @ 0 corner: (scrollBar computeWidth) @ (adapter circleButtonSize)))
	]! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/25/2014 17:59'!
bounds: newBounds
	|rect left right   |
	
	rect := newBounds.
	
	left := rect origin.
	right := rect corner.
	
	rect := left corner: right.
	
	super bounds: rect! !

!GLMPagerBarMorph methodsFor: 'initialization' stamp: 'TudorGirba 4/16/2014 14:29'!
initialize
	super initialize.
		
	self 
		color: Color transparent;
		changeProportionalLayout;
		borderWidth: 0.
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/29/2014 00:07'!
onPagePoped

	buttons onPagePoped.
	self recomputeScrollBar.! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/29/2014 00:07'!
onPagePushed: addedAnnouncement

	buttons onPagePushed: addedAnnouncement.
	self recomputeScrollBar.! !

!GLMPagerBarMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 6/28/2014 23:50'!
recomputeScrollBar
	
	scrollBar ifNotNil: [
		scrollBar width: scrollBar computeWidth.
		scrollBar setWidthAfterResizing.
	]! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 16:47'!
width
	^ buttons width! !

Morph subclass: #GLMPagerMorph
	instanceVariableNames: 'adapter firstCombination pagerBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerMorph class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/29/2014 12:09'!
simpleExample
	|pager adapter|
	adapter := GLMPagerModel new.
	pager :=	GLMPagerMorph new.
	pager adapter: adapter.
	
	pager pushPane: (Morph new color: Color red).
	pager pushPane: (Morph new color: Color green).
	pager pushPane: (Morph new color: Color yellow).
	pager pushPane: (Morph new color: Color blue).
	pager pushPane: (Morph new color: Color pink).
	
	pager height: 600.
	pager width: 1024.
	pager openInWindow.
	
	"pager inspect."! !

!GLMPagerMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 17:32'!
adapter
	^ adapter! !

!GLMPagerMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/29/2014 00:13'!
adapter: anObject
	adapter := anObject.
	
	self addMorphBack: (GLMPagerScrollMorph new adapter: adapter).
	
	pagerBar := GLMPagerBarMorph new adapter: adapter.
	
	adapter announcer weak
		on: GLMPagePushed send: #onPagePushed to: self.
		
	adapter announcer weak
		on: GLMPagePoped send: #onPagePoped to: self.
	
	self initializeShortcuts.! !

!GLMPagerMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/19/2014 19:16'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."

	^ Color transparent! !

!GLMPagerMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/19/2014 19:34'!
initialize
	super initialize.
	self changeTableLayout;
		changeListDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cellPositioning: #center;
		listCentering: #center;
		wrapCentering: #center! !

!GLMPagerMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/23/2014 19:39'!
initializeShortcuts

	self bindKeyCombination: Character arrowLeft alt command toAction: [ adapter selectToLeft ].
	self bindKeyCombination: Character arrowRight alt command toAction: [ adapter selectToRight ].
	
	self bindKeyCombination: Character arrowLeft alt shift command toAction: [
		self pressedScrollerSizeCombination: #left.
	].

	self bindKeyCombination: Character arrowRight alt shift command toAction: [
		self pressedScrollerSizeCombination: #right.
	].! !

!GLMPagerMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 6/29/2014 00:10'!
onPagePoped

	self showOrHideScrollBar.! !

!GLMPagerMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 6/29/2014 00:10'!
onPagePushed

	self showOrHideScrollBar.! !

!GLMPagerMorph methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/27/2014 19:32'!
outOfWorld: aWorld

	GLMPagerPanePreviewMorph remove.
	^ super outOfWorld: aWorld.! !

!GLMPagerMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:49'!
popAndReplacePane: aMorph
	adapter popAndReplacePane: aMorph! !

!GLMPagerMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:45'!
popPane
	adapter popPane.! !

!GLMPagerMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 16:27'!
pressedScrollerSizeCombination: aSymbol

	firstCombination ifNil: [ firstCombination := aSymbol. ^ self].
	
	self scrollerSizeShortcutAction: firstCombination second: aSymbol.
	firstCombination := nil.! !

!GLMPagerMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 16:04'!
pushPane: aMorph

	adapter pushPane: aMorph smooth: true.
	! !

!GLMPagerMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 15:48'!
scrollerSizeShortcutAction: first second: second
	
	(first = #left & second = #left) ifTrue: [ adapter enlargeToLeft ].
	(first = #left & second = #right) ifTrue: [ adapter diminishToRight ].
	(first = #right & second = #left) ifTrue: [ adapter diminishToLeft ].
	(first = #right & second = #right) ifTrue: [ adapter enlargeToRight ]! !

!GLMPagerMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 6/29/2014 00:19'!
showOrHideScrollBar
	
	(adapter size > 1)
		ifTrue: [ self addMorphBack: pagerBar ]
		ifFalse: [ self removeMorph: pagerBar ].! !

Morph subclass: #GLMPagerPaneButtonsMorph
	instanceVariableNames: 'adapter indicatorButtons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerPaneButtonsMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/25/2014 17:59'!
adapter: anAdapter
	
	adapter := anAdapter.
		
	adapter announcer weak
		on: GLMPageSwitched send: #onPageSwitched to: self.
				
	adapter announcer weak
		on: GLMPagerBoundsChanged send: #onScrollBoundsChanged: to: self.
		
	adapter announcer weak
		on: GLMFocusedPageChanged send: #onFocusedPageChanged to: self.
		
	self updateIndicatorButtons.! !

!GLMPagerPaneButtonsMorph methodsFor: 'adding' stamp: 'AliakseiSyrel 6/28/2014 22:22'!
addScrollButton: aMorph
	self addMorphBack: aMorph.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/25/2014 17:59'!
buttonCenterByIndex: aNumber
	|left width|
	width := adapter circleButtonSize.
	left := self bounds left.
	^ left + ( ( aNumber - 1 ) * ( width ) ) + ( width / 2 ).! !

!GLMPagerPaneButtonsMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/6/2014 13:28'!
initialize
	super initialize.
		
	self changeTableLayout;
		changeListDirection: #leftToRight;
		cellPositioning: #center;
		listCentering: #center;
		wrapCentering: #center;
		color: Color transparent.
		
	self hResizing: #shrinkWrap.
	
	
	indicatorButtons := OrderedCollection new.! !

!GLMPagerPaneButtonsMorph methodsFor: 'testing' stamp: 'AliakseiSyrel 6/28/2014 22:22'!
isScrollMustBeChecked: anIndex withLeft: leftBound andRight: rightBound
	| buttonCenter |
	
	buttonCenter := self buttonCenterByIndex: anIndex.
	^ (leftBound <= buttonCenter ) & (rightBound > buttonCenter)! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:22'!
markButtonsInside: aBounds
	""
	|index boundsLeft boundsRight firstFound lastFound |	
	
	firstFound := false.
	lastFound := false.
	index := 0.
	
	(adapter size = 0) ifTrue: [ ^ self ].
	boundsLeft := aBounds x.
	boundsRight := aBounds y.
	
	indicatorButtons do: [ :indicator |
		index := index + 1.
		(self isScrollMustBeChecked: index withLeft: boundsLeft andRight: boundsRight)
			ifTrue: [
				indicator buttonModel check.
				firstFound ifFalse: [
					adapter virtualFirstVisiblePageIndex: index.
					firstFound := true.
				]
			]
			ifFalse: [
				"uncheck only if not focused"
				indicator isFocused ifFalse: [ indicator buttonModel uncheck ].
				(firstFound & (lastFound = false)) ifTrue: [
					adapter virtualLastVisiblePageIndex: index - 1.
					lastFound := true.
				]
			].
	].
	lastFound ifFalse: [
		adapter virtualLastVisiblePageIndex: index.
		lastFound := true.
	]
	
		
! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 19:36'!
onFocusedPageChanged

	self updateIndicatorButtonsFocus.
	self updateIndicatorButtons.
! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:22'!
onPagePoped
	|button|
	
	button := indicatorButtons last.
	indicatorButtons removeLast.
	button announcer unsubscribe: self.
	
	self removeScrollButton: button.
	self updateIndicatorButtons.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:46'!
onPagePushed: addedAnnouncement
	|button|
	
	button := GLMPagerScrollButtonMorph new.
	indicatorButtons addLast: button.
	
	button buttonModel: (GLMPagerScrollButtonModel new pageIndex: indicatorButtons size).
	button buttonModel on: GLMPagerButtonClicked send: #scrollButtonClicked: to: self.
	button buttonModel on: GLMPagerButtonSelected send: #scrollButtonSelected: to: self.
	button buttonModel on: GLMPagerButtonDeselected send: #scrollButtonDeselected to: self.
	
	adapter scrollButtonIconRenderBlock ifNotNil: [
		self renderCustomScrollButtonIcons: (adapter scrollButtonIconRenderBlock value: indicatorButtons size) for: button.
	]	ifNil: [ 
		GLMPagerWidgetThemer new defaultScrollButtonStyleFor: button.
	].
	
	
	button height: adapter circleButtonSize.
	button width: adapter circleButtonSize.
	
	self addScrollButton: button.
	
	(indicatorButtons size = 1) ifTrue: [ self updateIndicatorButtonsFocus ].
		
	self updateIndicatorButtons.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 21:04'!
onPageSwitched

	self updateIndicatorButtons.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 21:04'!
onScrollBoundsChanged: boundsChangedAnnouncement

	self markButtonsInside: boundsChangedAnnouncement bounds.
	! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:22'!
removeScrollButton: aButton

	self removeMorph: aButton.! !

!GLMPagerPaneButtonsMorph methodsFor: 'testing' stamp: 'AliakseiSyrel 6/29/2014 00:58'!
renderCustomScrollButtonIcons: anIcons for: aButton
	| normalIcon focusedIcon source iconSize|
	
	anIcons isCollection ifTrue: [ 
		normalIcon := anIcons first.
		focusedIcon := anIcons second.
	]
	ifFalse: [ 
		focusedIcon := anIcons.
		normalIcon := (AlphaImageMorph new image: anIcons asGrayScaleWithAlpha; alpha: 0.6) cachedForm.
	].

	iconSize := adapter circleButtonSize @ adapter circleButtonSize.
	
	source := GLMForm scaleForm: normalIcon to: iconSize / 1.6.
	normalIcon := GLMForm increaseFormExtentCentered: source to: iconSize.
	
	source := GLMForm scaleForm: focusedIcon to: iconSize / 1.6.
	focusedIcon := GLMForm increaseFormExtentCentered: source to: iconSize.
	
	aButton checkedIcon: normalIcon.
	aButton checkedFocusedIcon: focusedIcon.
	
	aButton image state normal: normalIcon.
	aButton image state selected: focusedIcon.
	aButton image state checked: aButton checkedIcon.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:46'!
scrollButtonClicked: clickedAnnouncement

	"notify adapter that we need to switch page"
	adapter switchPaneTo: clickedAnnouncement buttonModel pageIndex.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:46'!
scrollButtonDeselected

	GLMPagerPanePreviewMorph uniqueInstance hideFromWorld.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:46'!
scrollButtonSelected: selectedAnnouncement

	"notify adapter that we need to update pane preview"
	
	GLMPagerPanePreviewMorph uniqueInstance showAt: (indicatorButtons at: selectedAnnouncement buttonModel pageIndex) bounds topCenter.
	adapter updatePreview: selectedAnnouncement buttonModel pageIndex.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/26/2014 19:33'!
updateIndicatorButtons

	"first we uncheck all buttons"
	indicatorButtons do: [ :indicator |
		"uncheck only if not focused"
		indicator isFocused ifFalse: [ indicator buttonModel uncheck ].
	].

	"then check only necessary"
	adapter size > 0 ifTrue: [
		indicatorButtons from: adapter firstVisiblePageIndex to: adapter lastVisiblePageIndex do: [ :indicator |
			indicator buttonModel check.
		]
	]! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 19:28'!
updateIndicatorButtonsFocus

	"unfocus all"
	indicatorButtons do: [ :each |
		 each setNotFocused.
	].
	
	"because it's possible when nothing has focus"
	adapter focusedPageIndex ifNotNil: [ (indicatorButtons at: adapter focusedPageIndex) setFocused ].
	! !

!GLMPagerPaneButtonsMorph methodsFor: 'geometry' stamp: 'AliakseiSyrel 6/25/2014 18:00'!
width
	|width|
	width := adapter isNotNil
		ifTrue: [ ( indicatorButtons size * ( adapter circleButtonSize ) ) ]
		ifFalse: [ 0 ].
	^ width! !

GLMPagerPaneButtonsMorph subclass: #GLMPagerPaneDependencyButtonsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerPaneDependencyButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/29/2014 00:39'!
addScrollButton: aMorph
	|arrowScaleMultiplier|
	arrowScaleMultiplier := 2.
	
	adapter size > 1 ifTrue: [
		self addMorphBack: (ImageMorph withForm: (GLMForm increaseFormExtentCentered: (GLMForm scaleForm: GLMUIThemeExtraIcons glamorousPlay to: (adapter dependencyButtonSize @ adapter dependencyButtonSize) / arrowScaleMultiplier ) to: (adapter dependencyButtonSize @ adapter dependencyButtonSize)))
	].
	
	super addScrollButton: aMorph.! !

!GLMPagerPaneDependencyButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 18:00'!
buttonCenterByIndex: aNumber isLeft: isLeft
	|button|
	button := indicatorButtons at: aNumber.
	^ isLeft ifTrue: [ button right ]
				ifFalse: [ button left ]! !

!GLMPagerPaneDependencyButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:22'!
isScrollMustBeChecked: anIndex withLeft: leftBound andRight: rightBound

	^ (leftBound <= (self buttonCenterByIndex: anIndex isLeft: true) ) & (rightBound > (self buttonCenterByIndex: anIndex isLeft: false))! !

!GLMPagerPaneDependencyButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/29/2014 00:37'!
removeScrollButton: aButton

	self removeMorph: aButton.
	
	adapter size > 0 ifTrue: [ 
		self removeMorph: (self submorphs last).
	]! !

!GLMPagerPaneDependencyButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/25/2014 18:00'!
width
	|width|
	width := adapter isNotNil
		ifTrue: [ ((indicatorButtons size * (adapter circleButtonSize )) + ((indicatorButtons size - 1) * adapter dependencyButtonSize)) ]
		ifFalse: [ 0 ].
	^ width! !

ImageMorph subclass: #GLMPagerPanePreviewMorph
	instanceVariableNames: 'thumbnail position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

GLMPagerPanePreviewMorph class
	instanceVariableNames: 'uniqueInstance'!

!GLMPagerPanePreviewMorph commentStamp: 'AndreiChis 5/27/2014 19:59' prior: 0!
I am a morph showing a preview image of another morph.  I should be used like a singleton: my class provides an unique instance of me. That instance can be hiden, shown or updated.!

GLMPagerPanePreviewMorph class
	instanceVariableNames: 'uniqueInstance'!

!GLMPagerPanePreviewMorph class methodsFor: 'actions' stamp: 'AndreiChis 5/27/2014 19:32'!
remove

	self uniqueInstance delete.	
	uniqueInstance := nil.! !

!GLMPagerPanePreviewMorph class methodsFor: 'accessing' stamp: 'AndreiChis 5/27/2014 19:31'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := GLMPagerPanePreviewMorph new ].! !

!GLMPagerPanePreviewMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 5/26/2014 14:17'!
align: aPoint
	
	position := aPoint.! !

!GLMPagerPanePreviewMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 5/26/2014 14:37'!
defaultBorderWidth
	^ 5! !

!GLMPagerPanePreviewMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 5/26/2014 15:16'!
defaultBottomMargin
	^ 11! !

!GLMPagerPanePreviewMorph methodsFor: 'actions' stamp: 'AndreiChis 5/27/2014 19:38'!
hideFromWorld
	"Remove the morph from the world"
	self delete! !

!GLMPagerPanePreviewMorph methodsFor: 'initialization' stamp: 'AndreiChis 5/27/2014 19:30'!
initialize
	super initialize.

	self color: Color transparent.
	
	self theme pagerWidgetThemer previewPaneStyleFor: self.
	self borderWidth: self defaultBorderWidth.! !

!GLMPagerPanePreviewMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 5/26/2014 14:18'!
maxExtent
	^ 300@300.! !

!GLMPagerPanePreviewMorph methodsFor: 'actions' stamp: 'AndreiChis 5/27/2014 19:42'!
showAt: aPoint

	self 
		openInWorld;
		align: aPoint.! !

!GLMPagerPanePreviewMorph methodsFor: 'actions' stamp: 'AndreiChis 5/27/2014 19:40'!
updateFor: aMorph
	thumbnail := aMorph taskThumbnailOfSize: self maxExtent.
	self image: thumbnail form.
	
	self position: position - ((thumbnail width / 2)@(thumbnail height + self defaultBottomMargin + self defaultBorderWidth)).! !

Announcement subclass: #GLMEventHandlerAnnouncement
	instanceVariableNames: 'selector recipient event sourceMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
event
	^ event! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
event: anObject
	event := anObject! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
recipient
	^ recipient! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
recipient: anObject
	recipient := anObject! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
selector
	^ selector! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
selector: anObject
	selector := anObject! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
sourceMorph
	^ sourceMorph! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
sourceMorph: anObject
	sourceMorph := anObject! !

Announcement subclass: #GLMFocusedPageChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMNumberOfVisiblePagesChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagePoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagePushed
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagePushed methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 12:42'!
morph
	^ morph! !

!GLMPagePushed methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 12:42'!
morph: aMorph
	morph := aMorph! !

Announcement subclass: #GLMPageSwitched
	instanceVariableNames: 'smooth pageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/23/2014 18:36'!
pageIndex
	^ pageIndex! !

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/23/2014 18:36'!
pageIndex: anObject
	pageIndex := anObject! !

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 17:46'!
smooth
	^ smooth! !

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 17:46'!
smooth: anObject
	smooth := anObject! !

Announcement subclass: #GLMPagerBoundsChanged
	instanceVariableNames: 'bounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerBoundsChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 15:29'!
bounds
	^ bounds! !

!GLMPagerBoundsChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 15:29'!
bounds: anObject
	bounds := anObject! !

Announcement subclass: #GLMPagerButtonAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonChecked
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonClicked
	instanceVariableNames: 'buttonModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerButtonClicked methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 11:25'!
buttonModel
	^ buttonModel! !

!GLMPagerButtonClicked methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 11:25'!
buttonModel: anObject
	buttonModel := anObject! !

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonDepressed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonDeselected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonPressed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonReleased
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonSelected
	instanceVariableNames: 'buttonModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerButtonSelected methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 13:56'!
buttonModel
	^ buttonModel! !

!GLMPagerButtonSelected methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 13:56'!
buttonModel: anObject
	buttonModel := anObject! !

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonUnChecked
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagerButtonFontUpdated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagerButtonImageUpdated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagerPreviewUpdate
	instanceVariableNames: 'pageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerPreviewUpdate methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 13:49'!
pageIndex
	^ pageIndex! !

!GLMPagerPreviewUpdate methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 13:49'!
pageIndex: anObject
	pageIndex := anObject! !

Announcement subclass: #GLMPagerScrollPositionChanged
	instanceVariableNames: 'smooth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerScrollPositionChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/27/2014 13:44'!
smooth
	^ smooth! !

!GLMPagerScrollPositionChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/27/2014 13:44'!
smooth: anObject
	smooth := anObject! !

Announcement subclass: #GLMPagerSynchronizeScrollAnnouncement
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerSynchronizeScrollAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 14:18'!
value
	^ value! !

!GLMPagerSynchronizeScrollAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 14:18'!
value: anObject
	value := anObject! !

Announcement subclass: #GLMSelectedPageChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!UITheme methodsFor: '*Glamour-Morphic-Pager-Morphic' stamp: 'AndreiChis 4/24/2014 13:42'!
pagerWidgetThemer
	^ GLMPagerWidgetThemer new! !

BorderedMorph subclass: #GLMPageScroller
	instanceVariableNames: 'sizing transform scrollBar paneCount maxPanes panes currentScrollValue focus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
adjustPaneHeight
	"This gets called after the scrollbar has been shown or hidden, to move the bottom
	of the panes to the right place."
	
	transform bounds: self innerBounds.
	transform submorphsDo: [:m | m bounds: (m bounds withHeight: self paneHeight)]! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
adoptPaneColor: aColor
	super adoptPaneColor: aColor.
	scrollBar adoptPaneColor: aColor! !

!GLMPageScroller methodsFor: 'private' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
basicUpdateSizing
	sizing := (self paneCount min: self maxPanes) max: 1! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
bounds: aRectangle
	super bounds: aRectangle.
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
computeMorphWidths
	| paneWidths widths |
	paneWidths := self paneWidthsToFit: self totalPaneWidth.
	widths := OrderedCollection new.
	paneWidths do: [:w | widths add: w] separatedBy: [widths add: self separatorWidth].
	^ widths asArray
! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 20:35'!
computeScrollValueToPaneByIndex: aNumber
	|value|
	"self halt."
	self totalScrollRange.
	self innerBounds width.
	value := (self leftoverScrollRange = 0)
		ifFalse: [(((panes at: aNumber) position x) / self leftoverScrollRange) "asFloat"]
		ifTrue: [ 0 ].
	^ value.! !

!GLMPageScroller methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 19:49'!
currentScrollValue
	^ currentScrollValue! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 20:18'!
glmAnimateValue: aValue duration: anInteger

	anInteger <= 0
		"if duration is zero, move to the left immediately"
		ifTrue: [ self leftTo: aValue ]
		ifFalse: [
			| startTime start currentValue |
			currentValue := self currentScrollValue.
			startTime := Time millisecondClockValue.
			start := currentValue.
			[	| delta |
				[ (delta := Time millisecondClockValue - startTime) < anInteger ] whileTrue: [
					self scrollValue: (aValue - start) * (delta / anInteger) + start.
					Processor yield
				].
				self scrollValue: aValue
			] fork
		]! !

!GLMPageScroller methodsFor: 'initialization' stamp: 'AliakseiSyrel 5/26/2014 19:53'!
initialize
	super initialize.
	self 
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
	
	currentScrollValue := 0.
	paneCount := 0.
	maxPanes := 2.
	panes := OrderedCollection new.
	focus := Dictionary new.! !

!GLMPageScroller methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/5/2014 20:18'!
initializeScrollbar
	scrollBar := ScrollBar new 
		model: self;
		setValueSelector: #scrollValue:;
		yourself.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset.
! !

!GLMPageScroller methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
initializeTransform
	transform := TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout;
		bounds: super innerBounds.
	self addMorphBack: transform.
! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
layoutPanes
	| widths rect |
	widths := self computeMorphWidths.
	rect := 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect := rect withWidth: w.
						m bounds: rect.
						rect := rect translateBy: (w@0)]
						
! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/5/2014 20:11'!
layoutWidgets

	transform bounds: self innerBounds.! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 13:29'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width) max: 0
! !

!GLMPageScroller methodsFor: 'configuration' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
maxPanes
	^ maxPanes! !

!GLMPageScroller methodsFor: 'configuration' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
maxPanes: anInteger
	maxPanes := anInteger! !

!GLMPageScroller methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 14:13'!
paneAt: anIndex
	^ self panes at: anIndex.! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
paneCount
	^ paneCount! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
paneHeight
	^ transform bounds height! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 5/26/2014 19:55'!
paneWidthsToFit: limit
	| padded |
	padded := Array new: self paneCount.
	self paneCount = 0 ifTrue: [ ^ padded ].
	padded atAllPut: (limit / self sizing) floor.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded
	
	! !

!GLMPageScroller methodsFor: 'accessing' stamp: 'AndreiChis 5/7/2014 21:31'!
panes

	^ panes! !

!GLMPageScroller methodsFor: 'panes' stamp: 'AliakseiSyrel 4/4/2014 10:09'!
popAndReplacePane: aMorph	
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	"remove from collection"
	panes removeLast.
	paneCount := paneCount - 1.	
	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	"adding morph to collection"
	panes addLast: aMorph.
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPageScroller methodsFor: 'panes' stamp: 'AliakseiSyrel 4/4/2014 10:08'!
popPane
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	"remove from collection"
	panes removeLast.
	paneCount := paneCount - 1.
	self updatePanes.! !

!GLMPageScroller methodsFor: 'panes' stamp: 'AndreiChis 5/23/2014 17:47'!
pushPane: aMorph	
	aMorph 
		borderWidth: 1;
		borderColor: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	"adding morph to collection"
	panes addLast: aMorph.
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 20:18'!
scrollValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.
	currentScrollValue := value.! !

!GLMPageScroller methodsFor: 'panes' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
separator
	^ "BorderedSubpaneDividerMorph new 
		vertical;
		adoptPaneColor: self paneColor;
		yourself"
		
	GLMMorphic emptyMorph! !

!GLMPageScroller methodsFor: 'layout' stamp: 'TudorGirba 4/17/2014 00:04'!
separatorWidth
	^ 10! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 20:08'!
setScrollDeltas
	self scrollTo: self currentScrollValue smooth: false.! !

!GLMPageScroller methodsFor: 'updating' stamp: 'AliakseiSyrel 4/5/2014 20:18'!
setScrollDeltasSmooth
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range := self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval := ((self innerBounds width) / self totalScrollRange) asFloat.
	value := (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!GLMPageScroller methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
sizing
	^ sizing ifNil: [self updateSizing]! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
totalPaneWidth
	^ self innerBounds width - ((self sizing - 1) * self separatorWidth)! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!GLMPageScroller methodsFor: 'updating' stamp: 'AliakseiSyrel 4/5/2014 20:14'!
updatePanes
	self basicUpdateSizing.
	self layoutPanes.
	self setScrollDeltasSmooth.! !

!GLMPageScroller methodsFor: 'updating' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
updateSizing
	| old |
	old := sizing.
	self basicUpdateSizing.
	sizing = old ifFalse: [self layoutPanes].
	^sizing! !

GLMPageScroller subclass: #GLMPagerScrollMorph
	instanceVariableNames: 'pane adapter currentFocus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/27/2014 23:53'!
adapter: anAdapter
	
	adapter := anAdapter.
	
	adapter announcer weak
		on: GLMPagePushed send: #onPagePushed: to: self.
	
	adapter announcer weak
		on: GLMPagePoped send: #onPagePoped to: self.
						
	adapter announcer weak
		on: GLMPagerSynchronizeScrollAnnouncement send: #onSynchronizeScroll: to: self.
		
	adapter announcer weak 
		on: GLMPagerScrollPositionChanged send: #onScrollPositionChanged: to: self.
		
	adapter announcer weak 
		on: GLMNumberOfVisiblePagesChanged send: #onPagesNumberChanged to: self.
		
	adapter announcer weak 
		on: GLMSelectedPageChanged send: #onSelectedPageChanged to: self.
		
	adapter announcer weak 
		on: GLMPagerPreviewUpdate send: #onPagePreviewUpdate: to: self.! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 19:31'!
focusChanged: anEvent
	| pageIndex newFocus |
	
	newFocus := anEvent morph.
	
	currentFocus = newFocus ifFalse: [
		currentFocus := newFocus.
		pageIndex := self pageOf: newFocus.
	
		(pageIndex > 0) ifTrue: [
			adapter focusedMorphChanged: newFocus at: pageIndex.
		]
	]! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/27/2014 14:39'!
initialize
	super initialize.
	
	self color: Color transparent.
	
	Morph announcer weak 
		on: MorphGotFocus send: #focusChanged: to: self.! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:35'!
onPagePoped
	self popPane.
	! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/27/2014 19:40'!
onPagePreviewUpdate: updateAnnouncement

	GLMPagerPanePreviewMorph uniqueInstance updateFor: (self paneAt: updateAnnouncement pageIndex).! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 17:31'!
onPagePushed: pushedAnnouncement

	"added new page to the end of pane"
	self pushPane: pushedAnnouncement morph.
	
	
	
	
! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/27/2014 13:50'!
onPagesNumberChanged

	self maxPanes: adapter numberOfVisiblePages.
	self basicUpdateSizing.
	self layoutPanes.
	self scrollToPane: adapter firstVisiblePageIndex smooth: false.! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/27/2014 13:48'!
onScrollPositionChanged: announcement

	self scrollToPane: adapter firstVisiblePageIndex smooth: announcement smooth.! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/27/2014 23:53'!
onSelectedPageChanged
	
	panes do: [ :each | each borderColor: Color transparent ].
	
	self theme pagerWidgetThemer selectedPaneStyleFor: (panes at: adapter selectedPageIndex)! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/27/2014 14:27'!
onSynchronizeScroll: announcement

	"directly scrolls to value"
	self scrollTo: announcement value smooth: false.
	! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 17:32'!
outOfWorld: aWorld

	Morph announcer unsubscribe: self.
	^ super outOfWorld: aWorld.! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 17:25'!
pageOf: aSubMorph
	"returns 0 if morph is not in pager"
	|parent page|	
	
	aSubMorph ifNil: [ ^ 0 ].
	
	parent := aSubMorph.
	
	[parent isNotNil & ((parent == transform) not) ] whileTrue: [
		page := parent.
		parent := parent owner.
	].
	
	^ parent isNil ifTrue: [ 0 ] ifFalse: [ panes indexOf: page. ].
	! !

!GLMPagerScrollMorph methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 13:51'!
scrollTo: aValue smooth: isSmooth

 	isSmooth ifTrue: [	self glmAnimateValue: aValue duration: 200]
				ifFalse: [self scrollValue: aValue ].! !

!GLMPagerScrollMorph methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/28/2014 00:58'!
scrollToPane: anIndex smooth: isSmooth

	self scrollTo: (adapter convertIndexToValue: anIndex) smooth: isSmooth.! !

!GLMMorphicRenderer methodsFor: '*Glamour-Morphic-Pager-Glamour' stamp: 'TudorGirba 6/14/2014 12:10'!
renderPager: aBrowser 
	^ aBrowser hasFixedSizePanes 
		ifTrue: [GLMMorphicPagerRenderer render: aBrowser from: self]
		ifFalse: []! !

Error subclass: #GLMPagerException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Exception'!

!GLMCompositePresentation methodsFor: '*Glamour-Morphic-Pager-Glamour' stamp: 'AliakseiSyrel 6/29/2014 00:59'!
pager
	^ self custom: GLMPager new! !

SimpleButtonMorph subclass: #GLMButton
	instanceVariableNames: 'fontModel buttonModel imageModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

GLMButton class
	instanceVariableNames: 'model'!

!GLMButton commentStamp: 'AliakseiSyrel 3/27/2014 22:18' prior: 0!
|form newForm|

form := ImageReadWriter formFromFileNamed: '9patch.png'.
newForm := Patch9Form scalePatch9Form: form size:  100@100.
(ImageMorph withForm: newForm) openInWindow.!

GLMButton class
	instanceVariableNames: 'model'!

!GLMButton class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
with: aModel
	^ ABCButtonView new model: aModel! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
buttonModel
	^ buttonModel! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 13:45'!
buttonModel: aModel
	buttonModel := aModel.
	
	buttonModel announcer weak
		on: GLMPagerButtonPressed send: #onPressed to: self.
	
	buttonModel announcer weak
		on: GLMPagerButtonDepressed send: #onDepressed to: self.
		
	buttonModel announcer weak
		on: GLMPagerButtonSelected send: #onSelected to: self.
		
	buttonModel announcer weak
		on: GLMPagerButtonDeselected send: #onDeselected to: self.
		
	buttonModel announcer weak
		on: GLMPagerButtonChecked send: #onChecked to: self.
	
	buttonModel announcer weak
		on: GLMPagerButtonUnChecked send: #onUnChecked to: self.! !

!GLMButton methodsFor: 'drawing' stamp: 'AliakseiSyrel 4/4/2014 10:53'!
drawOn: aCanvas
	|image|
	image := self image pressed: (self buttonModel isPressed) selected: (self buttonModel isSelected) checked: (self buttonModel isChecked).
	image ifNotNil: [
		aCanvas 
			translucentImage: (self resizeImage: image scale:  (bounds extent / image extent))
			at: bounds origin.
	].
	
	super drawOn: aCanvas.! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
font
	^ fontModel! !

!GLMButton methodsFor: 'accessing' stamp: 'TudorGirba 4/16/2014 07:33'!
font: aModel
	fontModel := aModel.
	
	fontModel announcer weak
		on: GLMPagerButtonFontUpdated send: #onFontUpdated to: self.! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
handlesMouseOver: evt
	^ true! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
image
	^ imageModel.! !

!GLMButton methodsFor: 'accessing' stamp: 'TudorGirba 4/16/2014 07:33'!
image: anImageModel
	imageModel := anImageModel.
	
	imageModel state announcer weak
		on: GLMPagerButtonImageUpdated send: #onImageUpdated to: self.! !

!GLMButton methodsFor: 'initialization' stamp: 'TudorGirba 4/16/2014 07:33'!
initialize

	self image: GLMPagerButtonImageModel new.
	self font: GLMPagerButtonFontModel new.
	self buttonModel: GLMPagerButtonModel new.
	
	super initialize.	
	
	self borderWidth: 0.
	
	self color: (Color transparent).! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
label: aString
	super label: aString font: self logicalFont.
	"we need to update label color because label in button is completely recreated =/ "
	label color: self font color.! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
logicalFont
	^ self font logicalFont! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
mouseDown: evt
	self buttonModel press
	! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
mouseEnter: evt
	self buttonModel select! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
mouseLeave: evt
	self buttonModel deselect! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
mouseUp: evt
	self buttonModel depress.
	(bounds containsPoint: evt position)
		ifFalse: [ self buttonModel deselect ] ! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/4/2014 10:48'!
onChecked
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onDepressed
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onDeselected
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onFontUpdated
	self label: self label.! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onImageUpdated
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onPressed
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onSelected
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/4/2014 10:48'!
onUnChecked
	self changed! !

!GLMButton methodsFor: 'drawing' stamp: 'AliakseiSyrel 4/2/2014 18:07'!
resizeImage: anImage scale: aScale
	^ anImage magnify: anImage boundingBox by: aScale smoothing: 2! !

GLMButton subclass: #GLMPagerScrollButtonMorph
	instanceVariableNames: 'checkedIcon checkedFocusedIcon focused'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerScrollButtonMorph commentStamp: 'AliakseiSyrel 5/26/2014 11:44' prior: 0!
A GLMPagerCircleButtonMorph is a grey circle representing one pane in the pager.

Instance Variables
	checkedFocusedIcon:		<Form>
	checkedIcon:			<Form>
	focused:					<Form>

checkedFocusedIcon
	- which icon will be used for focused+checked state

checkedIcon
	- which icon will be used for checked state

focused
	- which icon will be used for focused state
!

!GLMPagerScrollButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:18'!
checkedFocusedIcon
	^ checkedFocusedIcon! !

!GLMPagerScrollButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 18:05'!
checkedFocusedIcon: aForm
	checkedFocusedIcon := aForm.! !

!GLMPagerScrollButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:18'!
checkedIcon
	^ checkedIcon! !

!GLMPagerScrollButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 18:05'!
checkedIcon: aForm
	checkedIcon := aForm.! !

!GLMPagerScrollButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:17'!
initialize
	super initialize.
	
	self label: ''.
	focused := false.! !

!GLMPagerScrollButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 18:55'!
isFocused
	^ focused! !

!GLMPagerScrollButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 19:26'!
setFocused

	focused ifFalse: [
		self image state checked: checkedFocusedIcon.
		self buttonModel check.
		focused := true.
	]! !

!GLMPagerScrollButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/23/2014 19:27'!
setNotFocused

	focused ifTrue: [
		self image state checked: checkedIcon.
		self buttonModel uncheck.
		focused := false.
	]! !

GLMButton subclass: #GLMSlidingScrollMorph
	instanceVariableNames: 'startDragX isResizing startResizingWidth adapter resizingZoneWidth isRightResizing isLeftResizing scrollResizingIcon scrollSelectedIcon drawCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMSlidingScrollMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/27/2014 13:47'!
adapter: anAdapter
	
	adapter := anAdapter.
			
	adapter announcer weak 
		on: GLMNumberOfVisiblePagesChanged send: #onResized to: self.
		
	adapter announcer weak 
		on: GLMPagerScrollPositionChanged send: #onScrollPositionChanged: to: self.
		
	self width: self computeWidth.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/27/2014 13:31'!
computeScrollValue: aNumber
	|minLeft maxLeft value interval|
	
	minLeft := owner bounds left.
	maxLeft := owner bounds right - self width.
	
	aNumber < minLeft ifTrue: [ aNumber := minLeft ].
	aNumber > maxLeft ifTrue: [ aNumber := maxLeft ].
	
	interval := owner width.
		
	value := (interval = self width)
		ifTrue: [ 0.0 ]
		ifFalse: [ (aNumber - minLeft) / (interval - self width) ].
	
	^ value.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/25/2014 18:00'!
computeWidth
	|width numberOfVisiblePages|

	width := adapter isNotNil
		ifTrue: [
			numberOfVisiblePages := adapter numberOfVisiblePages.
			numberOfVisiblePages > adapter size
				ifTrue: [ numberOfVisiblePages := adapter size ].
			(adapter circleButtonSize) * numberOfVisiblePages + ((numberOfVisiblePages - 1) * adapter dependencyButtonSize).
		]
		ifFalse: [ 0 ].
		
	^ width.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 14:06'!
delete
	super delete.
	adapter announcer unsubscribe: self.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/25/2014 18:00'!
dragResizingLeft: evt
	| leftDelta left right maxLeft|
	
	leftDelta:= (self bounds right - startResizingWidth - evt position x - startDragX).
	
	right := self layoutFrame rightOffset.
	left := right - startResizingWidth - leftDelta.
	maxLeft := right - adapter circleButtonSize.
	
	left := (left max: 0) min: maxLeft.
	
	self layoutFrame: (
		LayoutFrame 
			fractions: (0 @ 0 corner: 0 @ 0)
			offsets: (left @ 0 corner: right @ self height)
	).
	
	adapter notifyScrollerBoundsChanged: (owner left + left)@(owner left + right).
	! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/25/2014 18:01'!
dragResizingRight: evt
	| rightDelta left right minRight maxRight|
	
	rightDelta:= (evt position x - self left - startDragX).
	
	left := self layoutFrame leftOffset.
	right := left + startResizingWidth + rightDelta.
	minRight := left + adapter circleButtonSize.
	maxRight := owner width.
	
	right := (right max: minRight) min: maxRight.
	
	self layoutFrame: (
		LayoutFrame 
			fractions: (0 @ 0 corner: 0 @ 0)
			offsets: (left @ 0 corner: right @ self height)
	).
	
	adapter notifyScrollerBoundsChanged: (owner left + left)@(owner left + right).
	! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/27/2014 14:28'!
dragSliding: evt
	| newLeft value|
	
	newLeft := (evt position x - startDragX).
	value := self computeScrollValue: newLeft.
	
	self scrollTo: value.
	self synchronizeScrollTo: value.! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/18/2014 11:39'!
handleMouseOver: anEvent
	super handleMouseOver: anEvent.
		
	isResizing | (self isMouseEventInsideLeftResizingZone: anEvent) | (self isMouseEventInsideRightResizingZone: anEvent)
	ifTrue: [
		self setCursorToResizing: anEvent.
	]
	ifFalse: [
		self setCursorToNormal: anEvent.
	].! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 18:40'!
handlesMouseOverDragging: evt
	^ true! !

!GLMSlidingScrollMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 5/28/2014 00:51'!
initialize
	super initialize.
	
	self label: ''.
	
	resizingZoneWidth := 7.
	isRightResizing := false.
	isLeftResizing := false.
	isResizing := false.
		
	self image state normal: GLMUIThemeExtraIcons glamorousLargeGrayCircleEmphasized.
	scrollResizingIcon := GLMUIThemeExtraIcons glamorousLargeGrayCircleEmphasized.
	scrollSelectedIcon := GLMUIThemeExtraIcons glamorousLargeGrayCircleEmphasized.
	
	drawCache := Dictionary new.! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/6/2014 12:43'!
isMouseEventInsideLeftResizingZone: evt
	|resizingRectangle bottom right|
	
	bottom := self bounds bottom.
	right := self bounds left + resizingZoneWidth.
	
	resizingRectangle := self bounds origin corner: right@bottom.
	
	^ resizingRectangle containsPoint: evt position.
	
	! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/6/2014 12:12'!
isMouseEventInsideRightResizingZone: evt
	|resizingRectangle top left|
	
	top := self bounds top.
	left := self bounds right - resizingZoneWidth.
	
	resizingRectangle := left@top corner: self bounds corner.
	
	^ resizingRectangle containsPoint: evt position.
	
	! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/17/2014 12:50'!
mouseDown: evt

	startDragX := (evt position x - self left).
	startResizingWidth := self width.
	
	isRightResizing := self isMouseEventInsideRightResizingZone: evt.
	
	"only one type of resizing is possible"
	isRightResizing ifFalse: [ 
		isLeftResizing := self isMouseEventInsideLeftResizingZone: evt.
	]
	ifTrue: [ isLeftResizing := false ].

	isResizing := (isLeftResizing or: isRightResizing).
	
	"during resizing we can use other image"
	isResizing ifTrue: [ self image state selected: scrollResizingIcon ].
	
	super mouseDown: evt.! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/6/2014 15:56'!
mouseLeave: evt

	self setCursorToNormal: evt.
	super mouseLeave: evt.! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/6/2014 15:27'!
mouseMove: evt

	isRightResizing
		ifTrue: [ self dragResizingRight: evt ]
		ifFalse: [
			isLeftResizing
				ifTrue: [ self dragResizingLeft: evt ]
				ifFalse: [ self dragSliding: evt ]
		].! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 5/26/2014 20:47'!
mouseUp: evt
	super mouseUp: evt.
	
	adapter recomputeState.
	
	isResizing
		ifTrue: [
			"adapter numberOfVisiblePagesChanged ifFalse: [ self onResized ]."
		]
		ifFalse: [
			"smooth scrolling to fisrt visible page"
			"adapter switchPageTo: adapter firstVisiblePageIndex updateFocus: false updateSelection: false."
		].	
	
	isResizing := false.
	
	"setting selected image to default after resize is complete"
	self image state selected: scrollResizingIcon.
	
	(bounds containsPoint: evt position)
		ifFalse: [ self setCursorToNormal: evt ]
		ifTrue: [ self setCursorToResizing: evt ] ! !

!GLMSlidingScrollMorph methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 13:34'!
moveLeft: left "Integer - pixels"

	"moves scrollbar inside parent to the specified left distance in pixels and notifies all listeners about that"
	| right |
	
	right := left + self computeWidth.
	
	self layoutFrame: (
		LayoutFrame 
			fractions: (0 @ 0 corner: 0 @ 0)
			offsets: (left @ 0 corner: right @ self height)
	).
	
	adapter notifyScrollerBoundsChanged: (owner left + left )@(owner left + right).! !

!GLMSlidingScrollMorph methodsFor: 'announcement handling' stamp: 'AliakseiSyrel 4/21/2014 13:06'!
onResized
	self setWidthAfterResizing.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/27/2014 13:47'!
onScrollPositionChanged: announcement

	self scrollToPane: adapter firstVisiblePageIndex smooth: announcement smooth.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 15:42'!
resizeCursor

	^ Cursor resizeForEdge: #left! !

!GLMSlidingScrollMorph methodsFor: 'drawing' stamp: 'TudorGirba 5/25/2014 13:57'!
resizeImage: anImage scale: aScale

	| form |
	form := (Form extent: (aScale * anImage extent) depth: 32).
	form fillColor: (Color veryLightGray alpha: 0.5).
	^ form ! !

!GLMSlidingScrollMorph methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 13:34'!
scrollTo: aFloat "Float - percentage/100"

	"scrolls to a specified float number which must be in interval [0.0, 1.0]"

	self moveLeft: (owner width - self width) * aFloat.! !

!GLMSlidingScrollMorph methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 12:38'!
scrollTo: aValue duration: anInteger

	anInteger <= 0
		"if duration is zero, move to the left immediately"
		ifTrue: [ self scrollTo: aValue ]
		ifFalse: [
			| startTime start currentValue |
			currentValue := self computeScrollValue: self bounds left.
			startTime := Time millisecondClockValue.
			start := currentValue.
			[	| delta |
				[ (delta := Time millisecondClockValue - startTime) < anInteger ] whileTrue: [
					self scrollTo: ((aValue - start) * (delta / anInteger) + start).
					Processor yield
				].
				self scrollTo: aValue.
			] fork
		]! !

!GLMSlidingScrollMorph methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 12:39'!
scrollTo: aValue smooth: aBoolean

	aBoolean
		ifTrue: [ self scrollTo: aValue duration: 200 ]
		ifFalse: [ self scrollTo: aValue ] ! !

!GLMSlidingScrollMorph methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 13:30'!
scrollToPane: anIndex smooth: isSmooth

	self scrollTo: (adapter convertIndexToValue: anIndex) smooth: isSmooth.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/18/2014 11:34'!
setCursorToNormal: evt
		
	evt hand showTemporaryCursor: nil! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/18/2014 11:34'!
setCursorToResizing: evt
	
	evt hand showTemporaryCursor: self resizeCursor! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/25/2014 18:01'!
setWidthAfterResizing
	| left right |
	
	left := ( adapter circleButtonSize + adapter dependencyButtonSize ) * (adapter firstVisiblePageIndex - 1).
	right := left + self computeWidth.
	
	self layoutFrame: (
		LayoutFrame 
			fractions: (0 @ 0 corner: 0 @ 0)
			offsets: (left @ 0 corner: right @ self height)
	).
	
	adapter notifyScrollerBoundsChanged: (owner left + left )@(owner left + right).! !

!GLMSlidingScrollMorph methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 14:28'!
synchronizeScrollTo: aValue

	adapter synchronizeScrollTo: aValue.! !

GLMFinder subclass: #GLMPager
	instanceVariableNames: 'scrollButtonIconRenderBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Glamour'!

!GLMPager methodsFor: 'rendering' stamp: 'AliakseiSyrel 6/28/2014 22:05'!
renderGlamorouslyOn: aRenderer

	^ aRenderer renderPager: self! !

!GLMPager methodsFor: 'accessing' stamp: 'AndreiChis 6/28/2014 21:16'!
scrollButtonIconRenderBlock

	^ scrollButtonIconRenderBlock! !

!GLMPager methodsFor: 'accessing' stamp: 'AndreiChis 6/28/2014 21:16'!
scrollButtonIconRenderBlock: aBlock

	scrollButtonIconRenderBlock := aBlock! !

TestCase subclass: #GLMPagerModelTest
	instanceVariableNames: 'pagerModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Tests'!

!GLMPagerModelTest methodsFor: 'private' stamp: 'AndreiChis 4/15/2014 11:42'!
createSimplePaneMorph

	^ Morph new! !

!GLMPagerModelTest methodsFor: 'running' stamp: 'AliakseiSyrel 5/27/2014 11:06'!
setUp

	pagerModel := GLMPagerModel new.
	pagerModel defaultNumberOfVisiblePages: 2.! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 11:08'!
testDiminishToLeft
	|counter left|
	
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	"assert that by default after creation the number of visible pages equals default value"
	counter := pagerModel numberOfVisiblePages.
	"position of left edge is a constant while diminishing to left"
	left := pagerModel firstVisiblePageIndex.
	self assert: pagerModel numberOfVisiblePages equals: counter.
	self assert: pagerModel numberOfVisiblePages equals: pagerModel lastVisiblePageIndex-left+1.
	self assert: pagerModel firstVisiblePageIndex equals: left.
	
	"diminish until numberOfVisible pages > 1"
	[ counter > 1 ] whileTrue: [
		pagerModel diminishToLeft.
		counter := counter - 1.
		self assert: pagerModel numberOfVisiblePages equals: counter.
		self assert: pagerModel numberOfVisiblePages equals: pagerModel lastVisiblePageIndex-left+1.
		self assert: pagerModel firstVisiblePageIndex equals: left.
	].

	"now the number of visible pages must be not less then 1"
	(1 to: 3) do: [ :i|
		pagerModel diminishToLeft.
		self assert: pagerModel numberOfVisiblePages equals: 1.
		self assert: pagerModel numberOfVisiblePages equals: pagerModel lastVisiblePageIndex-left+1.
		self assert: pagerModel firstVisiblePageIndex equals: left.
	].
! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 15:09'!
testDiminishToRight
	|counter right|
	
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	"assert that by default after creation the number of visible pages equals default value"
	counter := pagerModel defaultNumberOfVisiblePages.
	"position of right edge is a constant while diminishing to right"
	right := pagerModel lastVisiblePageIndex.
	self assert: pagerModel numberOfVisiblePages equals: counter.
	self assert: pagerModel numberOfVisiblePages equals: right - pagerModel firstVisiblePageIndex+1.
	self assert: pagerModel lastVisiblePageIndex equals: right.
	
	"diminish until numberOfVisible pages > 1"
	[ counter > 1 ] whileTrue: [
		pagerModel diminishToRight.
		counter := counter - 1.
		self assert: pagerModel numberOfVisiblePages equals: counter.
		self assert: pagerModel numberOfVisiblePages equals: right - pagerModel firstVisiblePageIndex+1.
		self assert: pagerModel lastVisiblePageIndex equals: right.
	].

	"now the number of visible pages must be not less then 1"
	(1 to: 3) do: [ :i|
		pagerModel diminishToRight.
		self assert: pagerModel numberOfVisiblePages equals: 1.
		self assert: pagerModel numberOfVisiblePages equals: right - pagerModel firstVisiblePageIndex+1.
		self assert: pagerModel lastVisiblePageIndex equals: right.
	].
! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 15:11'!
testEmptyPopPane
	| count |
	
	count := 0.
	pagerModel announcer when: GLMPagePoped do: [ :ann | count := count + 1 ].
	
	pagerModel popPane.
	
	self assert: count equals: 0.
	
	self assert: pagerModel size equals: 0.
	self assert: pagerModel firstVisiblePageIndex equals: 0.
	self assert: pagerModel lastVisiblePageIndex equals: 0.
	self assert: pagerModel numberOfVisiblePages equals: 2.
	
	pagerModel popPane.
	pagerModel popPane.
	
	self assert: count equals: 0.
	! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 23:18'!
testEnlargeToLeft
	|counter right |
	
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
		
	"assert that by default after creation the number of visible pages equals default value"
	counter := pagerModel numberOfVisiblePages.
	"position of right edge is a constant while enlarging to left"
	right := pagerModel lastVisiblePageIndex.
	self assert: pagerModel numberOfVisiblePages equals: counter.
	self assert: pagerModel numberOfVisiblePages equals: right - pagerModel firstVisiblePageIndex+1.
	self assert: pagerModel lastVisiblePageIndex equals: right.
	
	"enlarge until numberOfVisible pages > 1"
	[ counter < 6 ] whileTrue: [
		counter := counter + 1.
		pagerModel enlargeToLeft.
		self assert: pagerModel numberOfVisiblePages equals: counter.
		self assert: pagerModel numberOfVisiblePages equals: right - pagerModel firstVisiblePageIndex+1.
		self assert: pagerModel lastVisiblePageIndex equals: right.
	].

	"now the number of visible pages must be not bigger then 6"
	(1 to: 3) do: [ :i|
		pagerModel enlargeToLeft.
		self assert: pagerModel numberOfVisiblePages equals: 6.
		self assert: pagerModel numberOfVisiblePages equals: right - pagerModel firstVisiblePageIndex+1.
		self assert: pagerModel lastVisiblePageIndex equals: right.
		self assert: pagerModel firstVisiblePageIndex equals: 1.
	].
! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 23:22'!
testEnlargeToRight
	|counter left|
	
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	pagerModel scrollTo: 0.0 smooth: false.
	
	"assert that by default after creation the number of visible pages equals default value"
	counter := pagerModel numberOfVisiblePages.
	"position of left edge is a constant while enlargingto right"
	left := pagerModel firstVisiblePageIndex.
	self assert: pagerModel numberOfVisiblePages equals: counter.
	self assert: pagerModel numberOfVisiblePages equals: pagerModel lastVisiblePageIndex-left+1.
	self assert: pagerModel firstVisiblePageIndex equals: left.
	
	"diminish until numberOfVisible pages > 1"
	[ counter < 6 ] whileTrue: [
		counter := counter + 1.
		pagerModel enlargeToRight.
		self assert: pagerModel numberOfVisiblePages equals: counter.
		self assert: pagerModel numberOfVisiblePages equals: pagerModel lastVisiblePageIndex-left+1.
		self assert: pagerModel firstVisiblePageIndex equals: left.
	].

	"now the number of visible pages must be not bigger than 6"
	(1 to: 3) do: [ :i|
		pagerModel enlargeToRight.
		self assert: pagerModel numberOfVisiblePages equals: 6.
		self assert: pagerModel numberOfVisiblePages equals: pagerModel lastVisiblePageIndex-left+1.
		self assert: pagerModel firstVisiblePageIndex equals: left.
		self assert: pagerModel lastVisiblePageIndex equals: 6.
	].
! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 23:26'!
testIsPaneVisible

	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	self assert: pagerModel numberOfVisiblePages equals: 2.
	
	self assert: (pagerModel isPaneVisible: 1) equals: false.
	self assert: (pagerModel isPaneVisible: 2) equals: false.
	self assert: (pagerModel isPaneVisible: 3) equals: false.
	self assert: (pagerModel isPaneVisible: 4) equals: false.
	self assert: (pagerModel isPaneVisible: 5) equals: true.
	self assert: (pagerModel isPaneVisible: 6) equals: true.! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 11:41'!
testModelInitialization

	self assert: pagerModel size equals: 0.
	self assert: pagerModel firstVisiblePageIndex equals: 0.
	self assert: pagerModel lastVisiblePageIndex equals: 0.
	self assert: pagerModel actualNumberOfVisiblePages equals: 0.
	self assert: pagerModel numberOfVisiblePages equals: 2.! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 11:40'!
testOnePanePush
	
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	self assert: pagerModel size equals: 1.
	self assert: pagerModel firstVisiblePageIndex equals: 1.
	self assert: pagerModel lastVisiblePageIndex equals: 1.
	self assert: pagerModel numberOfVisiblePages equals: 2.
	! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 15:12'!
testOneReplacePane
	
	pagerModel popAndReplacePane: self createSimplePaneMorph.

	self assert: pagerModel size equals: 1.
	self assert: pagerModel firstVisiblePageIndex equals: 1.
	self assert: pagerModel lastVisiblePageIndex equals: 1.
	self assert: pagerModel numberOfVisiblePages equals: 2.
	! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'TudorGirba 4/15/2014 22:45'!
testPanePushAnnouncement
	| count currentAnn paneMorph |
	
	count := 0.
	paneMorph := self createSimplePaneMorph.
	pagerModel announcer when: GLMPagePushed do: [ :ann | count := count + 1. currentAnn := ann ].
	
	pagerModel pushPane: paneMorph smooth: false.
	self assert: count equals: 1.
	self assert: currentAnn morph equals: paneMorph.
	
	paneMorph := self createSimplePaneMorph.
	pagerModel pushPane: paneMorph smooth: false.
	self assert: count equals: 2.
	self assert: currentAnn morph equals: paneMorph.
	
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	self assert: count equals: 4.! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/27/2014 23:24'!
testPrivateRecomputeIndexesAfterScrollAt

	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	self assert: pagerModel firstVisiblePageIndex equals: 1.
	self assert: pagerModel lastVisiblePageIndex equals: 1.
	
	"raw first visible must be 1.0, last visible 1.0 and after rounding 1 and 1"
	pagerModel privateRecomputeIndexesAfterScrollAt: 1.0.
	
	self assert: pagerModel firstVisiblePageIndex equals: 1.
	self assert: pagerModel lastVisiblePageIndex equals: 1.
	
	"raw first visible must be 1.0, last visible 1.0 and after rounding 1 and 1"
	pagerModel privateRecomputeIndexesAfterScrollAt: 0.0.
	
	self assert: pagerModel firstVisiblePageIndex equals: 1.
	self assert: pagerModel lastVisiblePageIndex equals: 1.
		
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
		
	"raw first visible must be 1.0, last visible 1.0 and after rounding 1 and 1"
	pagerModel privateRecomputeIndexesAfterScrollAt: 0.0.
	
	self assert: pagerModel firstVisiblePageIndex equals: 1.
	self assert: pagerModel lastVisiblePageIndex equals: 2.
	
	"raw first visible must be 4.4, last visible 5.4 and after rounding 4 and 5"
	pagerModel privateRecomputeIndexesAfterScrollAt: 0.85.
	
	self assert: pagerModel firstVisiblePageIndex equals: 4.
	self assert: pagerModel lastVisiblePageIndex equals: 5.
	
	"raw first visible must be 4.6, last visible 5.6 and after rounding 5 and 6"
	pagerModel privateRecomputeIndexesAfterScrollAt: 0.9.
	
	self assert: pagerModel firstVisiblePageIndex equals: 5.
	self assert: pagerModel lastVisiblePageIndex equals: 6.
	
	"raw first visible must be 4.5, last visible 5.5 and after rounding 5 and 6"
	pagerModel privateRecomputeIndexesAfterScrollAt: 0.875.
	
	self assert: pagerModel firstVisiblePageIndex equals: 5.
	self assert: pagerModel lastVisiblePageIndex equals: 6.
	
	"raw first visible must be 5.0, last visible 6.0 and after rounding 5 and 6"
	pagerModel privateRecomputeIndexesAfterScrollAt: 1.0.
	
	self assert: pagerModel firstVisiblePageIndex equals: 5.
	self assert: pagerModel lastVisiblePageIndex equals: 6.! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/28/2014 00:42'!
testSelectToLeft

	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	pagerModel switchPaneTo: 6.
	
	self assert: pagerModel numberOfVisiblePages equals: 2.
	
	self assert: pagerModel selectedPageIndex equals: 6.
	self assert: pagerModel firstVisiblePageIndex equals: 5.
	self assert: pagerModel lastVisiblePageIndex equals: 6.
	
	pagerModel selectToLeft.
	
	self assert: pagerModel selectedPageIndex equals: 5.
	self assert: pagerModel firstVisiblePageIndex equals: 5.
	self assert: pagerModel lastVisiblePageIndex equals: 6.
	
	pagerModel selectToLeft.
	
	self assert: pagerModel selectedPageIndex equals: 4.
	self assert: pagerModel firstVisiblePageIndex equals: 4.
	self assert: pagerModel lastVisiblePageIndex equals: 5.
	
	pagerModel selectToLeft.
	
	self assert: pagerModel selectedPageIndex equals: 3.
	self assert: pagerModel firstVisiblePageIndex equals: 3.
	self assert: pagerModel lastVisiblePageIndex equals: 4.
	
	pagerModel selectToLeft.
	
	self assert: pagerModel selectedPageIndex equals: 2.
	self assert: pagerModel firstVisiblePageIndex equals: 2.
	self assert: pagerModel lastVisiblePageIndex equals: 3.
	
	pagerModel selectToLeft.
	
	self assert: pagerModel selectedPageIndex equals: 1.
	self assert: pagerModel firstVisiblePageIndex equals: 1.
	self assert: pagerModel lastVisiblePageIndex equals: 2.

	! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/28/2014 00:34'!
testSelectToRight

	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	pagerModel scrollTo: 0.0 smooth: false.
	
	self assert: pagerModel numberOfVisiblePages equals: 2.
	
	self assert: pagerModel selectedPageIndex equals: 1.
	self assert: pagerModel firstVisiblePageIndex equals: 1.
	self assert: pagerModel lastVisiblePageIndex equals: 2.
	
	pagerModel selectToRight.
	
	self assert: pagerModel selectedPageIndex equals: 2.
	self assert: pagerModel firstVisiblePageIndex equals: 1.
	self assert: pagerModel lastVisiblePageIndex equals: 2.
	
	pagerModel selectToRight.
	
	self assert: pagerModel selectedPageIndex equals: 3.
	self assert: pagerModel firstVisiblePageIndex equals: 2.
	self assert: pagerModel lastVisiblePageIndex equals: 3.
	
	pagerModel selectToRight.
	
	self assert: pagerModel selectedPageIndex equals: 4.
	self assert: pagerModel firstVisiblePageIndex equals: 3.
	self assert: pagerModel lastVisiblePageIndex equals: 4.
	
	pagerModel selectToRight.
	
	self assert: pagerModel selectedPageIndex equals: 5.
	self assert: pagerModel firstVisiblePageIndex equals: 4.
	self assert: pagerModel lastVisiblePageIndex equals: 5.
	
	pagerModel selectToRight.
	
	self assert: pagerModel selectedPageIndex equals: 6.
	self assert: pagerModel firstVisiblePageIndex equals: 5.
	self assert: pagerModel lastVisiblePageIndex equals: 6.! !

TestCase subclass: #GLMPagerMorphTest
	instanceVariableNames: 'pagerModel pagerMorph window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Tests'!

!GLMPagerMorphTest methodsFor: 'accessing' stamp: 'AndreiChis 5/7/2014 21:39'!
buttonsMorphs

	^ pagerMorph submorphs second submorphs second submorphs! !

!GLMPagerMorphTest methodsFor: 'private' stamp: 'AndreiChis 5/7/2014 21:19'!
createSimplePaneMorph

	^ Morph new! !

!GLMPagerMorphTest methodsFor: 'private' stamp: 'AndreiChis 5/7/2014 21:28'!
openInWindow

	window := pagerMorph openInWindow ! !

!GLMPagerMorphTest methodsFor: 'accessing' stamp: 'AndreiChis 5/7/2014 21:33'!
panesMorphs

	^ pagerMorph submorphs first panes! !

!GLMPagerMorphTest methodsFor: 'running' stamp: 'AndreiChis 5/7/2014 21:18'!
setUp

	pagerModel := GLMPagerModel new.
	pagerMorph := GLMPagerMorph new
		adapter: pagerModel
		yourself.! !

!GLMPagerMorphTest methodsFor: 'running' stamp: 'AndreiChis 5/7/2014 21:33'!
tearDown

	window ifNotNil: [ window delete ]! !

!GLMPagerMorphTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/26/2014 19:29'!
testPushPanesAfterOpen

	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	self openInWindow.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	self assert: pagerModel size equals: 3.
	self assert: self panesMorphs size equals: 3.
	self assert: self buttonsMorphs size equals: 3.
	
	
! !

!GLMPagerMorphTest methodsFor: 'tests' stamp: 'AliakseiSyrel 5/26/2014 19:29'!
testPushPanesBeforeOpen

	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.

	self openInWindow.
	
	self assert: pagerModel size equals: 3.
	self assert: self panesMorphs size equals: 3.
	self assert: self buttonsMorphs size equals: 3.
	
	
! !

Object subclass: #GLMForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMForm commentStamp: 'AliakseiSyrel 5/26/2014 15:14' prior: 0!
PNGReadWriter putForm: GLMUIThemeExtraIcons glamorousGrayCircle onFileNamed: 'glamorousGrayCircle.png'.
!

!GLMForm class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 23:08'!
increaseFormExtentCentered: aForm to: aPoint
	| icon rect destination |
	
	aForm ifNil: [ ^ nil ].
	rect := Rectangle origin: 0@0 extent: aPoint.
	destination := (rect extent - aForm extent) / 2.
	icon := Form extent: rect extent depth: aForm depth.
	icon copyBits: rect from: aForm at: destination clippingBox: icon boundingBox rule: Form over fillColor: nil.
	^ icon! !

!GLMForm class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 23:40'!
makeForm32Bit: aForm
	aForm ifNil: [ ^ nil ].
	aForm depth = 32 ifTrue: [ ^ aForm ].
	aForm depth: 32.
	aForm fixAlpha.
	^ aForm.! !

!GLMForm class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 23:37'!
makeFormTransparent: aForm factor: aFloat
	"a float must be in interval [0.0, 1.0]"
	| a |
	
	aForm ifNil: [ ^ nil ].
	aForm depth = 32 ifFalse: [^ aForm ].
	
	a := (aFloat * 255) asInteger.
	1 to: aForm bits size do: [:i |
		| v r g b |
		v := aForm bits at: i.
		r := ((v bitShift: -16) bitAnd: 255) * a // 255.
		g := ((v bitShift: -8) bitAnd: 255) * a // 255.
		b := (v bitAnd: 255) * a // 255.
		aForm bits at: i put: (a bitShift: 24) + (r bitShift: 16) + (g bitShift: 8) + b ].
	^ aForm ! !

!GLMForm class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:38'!
scaleForm: aForm by: aPoint

	aForm ifNil: [ ^ nil ].
	^ aForm magnify: aForm boundingBox by: aPoint smoothing: 2! !

!GLMForm class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:38'!
scaleForm: aForm to: aPoint
	|scaleX scaleY|
	
	aForm ifNil: [ ^ nil ].
	scaleX := aPoint x / aForm width.
	scaleY := aPoint y / aForm height.
	^ self scaleForm: aForm by: scaleX @ scaleY.! !

!GLMForm class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:38'!
scalePatchForm: aForm size: aPoint
	"aPoint - width and height of new form
	
|form|

form := PatchForm scalePatchForm: (ImageReadWriter formFromFileNamed: 'abc_calculator_button_normal.p.png') size:800@800.
(ImageMorph withForm: form) openInWindow.

form := ImageReadWriter formFromFileNamed: 'abc_calculator_button_normal.png'.
form := PatchForm scaleForm: form by: (800/(form extent x))@(800/(form extent y)).
(ImageMorph withForm: form) openInWindow.
	
	"
	
	|x0 x1 y0 y1 width height newForm tmpForm color bottomHeight rightWidth newMiddleWidth newMiddleHeight|
	
	aForm ifNil: [ ^ nil ].
	
	color := Color red.
	x0 := x1 := y0 := y1 := 0.
	width := aForm extent x.
	height := aForm extent y.
	
	(0 to: width-1) collect: [ :each |
		(aForm colorAt: each@0) = color ifTrue: [ 
			x0 = 0 ifTrue: [ 
				x0 := each.
			]
		] ifFalse:[
			(x0 > 0 & x1 = 0) ifTrue:[
				x1 := each.
			].
		].
	].

	(0 to: height) collect: [ :each |
		(aForm colorAt: 0@each) = color ifTrue: [ 
			y0 = 0 ifTrue: [ 
				y0 := each.
			]
		] ifFalse:[
			(y0 > 0 & y1 = 0) ifTrue:[
				y1 := each.
			].
		].
	].

	rightWidth := width - x1 -1.
	bottomHeight := height - y1 - 1.
	newMiddleWidth := aPoint x - x0 - rightWidth + 1.
	newMiddleHeight := aPoint y - y0 - bottomHeight + 1.
	
	newForm := Form extent: aPoint depth: aForm depth.
	"left top corner"
	newForm copyBits: (1@1 corner: x0@y0)
		from: aForm at: 0@0 clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	"left bottom corner"
	newForm copyBits: (1@y1 corner: x0@(height - 1))
		from: aForm at: 0@(aPoint y - bottomHeight) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	"right top corner"
	newForm copyBits: (x1@1 corner: (width-1)@y0)
		from: aForm at: (aPoint x - rightWidth)@0 clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	"right bottom corner"
	newForm copyBits: (x1@y1 corner: (width - 1)@(height - 1))
		from: aForm at: (aPoint x - rightWidth)@(aPoint y - bottomHeight) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	"top middle block"
	tmpForm := aForm copy: (x0@1 corner: x1@y0).
	tmpForm := self scaleForm: tmpForm by: ((newMiddleWidth)/(x1-x0))@1.
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (x0-1)@0 clippingBox: newForm boundingBox rule: Form over fillColor: nil.
		
	"bottom middle block"
	tmpForm := aForm copy: (x0@y1 corner: x1@height).
	tmpForm := self scaleForm: tmpForm by: ((newMiddleWidth)/(x1-x0))@1.
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (x0-1)@(aPoint y - bottomHeight) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	"left middle block"
	tmpForm := aForm copy: (1@y0 corner: x0@y1).
	tmpForm := self scaleForm: tmpForm by: 1@((newMiddleHeight)/(y1-y0)).
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: 0@(y0-1) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	"right middle block"
	tmpForm := aForm copy: (x1@y0 corner: width@y1).
	tmpForm := self scaleForm: tmpForm by: 1@((newMiddleHeight)/(y1-y0)).
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (aPoint x - rightWidth)@(y0-1) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
		
	"middle block"
	tmpForm := aForm copy: (x0@y0 corner: x1@y1).
	tmpForm := self scaleForm: tmpForm by: ((newMiddleWidth)/(x1-x0))@((newMiddleHeight)/(y1-y0)).
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (x0-1)@(y0-1) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	^ newForm.
	
! !

Object subclass: #GLMPagerButtonFontModel
	instanceVariableNames: 'font color familyName size announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
color
	^ color! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
color: aColor
	color := aColor.
	self updateFont.! !

!GLMPagerButtonFontModel methodsFor: 'defaults' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
defaultColor
	^ Color black! !

!GLMPagerButtonFontModel methodsFor: 'defaults' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
defaultFamilyName
	^ 'Bitmap DejaVu Sans'! !

!GLMPagerButtonFontModel methodsFor: 'defaults' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
defaultSize
	^ 15! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
familyName
	^ familyName! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
familyName: aString
	familyName := aString.
	self updateFont.! !

!GLMPagerButtonFontModel methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
initialize
	super initialize.
	
	size := self defaultSize.
	familyName := self defaultFamilyName.
	color := self defaultColor.
	
	self updateFont.
! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
logicalFont
	^ font! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
logicalFont: aFont
	font := aFont.
	familyName := font familyName.
	size := font pointSize.
	self notifyUpdate.! !

!GLMPagerButtonFontModel methodsFor: 'private' stamp: 'TudorGirba 4/16/2014 07:33'!
notifyUpdate
	self announcer announce: GLMPagerButtonFontUpdated new.! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
size
	^ size! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
size: aNumber
	size := aNumber.
	self notifyUpdate.! !

!GLMPagerButtonFontModel methodsFor: 'private' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
updateFont
	font := LogicalFont familyName: self familyName pointSize: self size.
	self notifyUpdate.! !

Object subclass: #GLMPagerButtonImageModel
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerButtonImageModel methodsFor: 'initialization' stamp: 'TudorGirba 4/16/2014 07:33'!
initialize
	super initialize.
	
	state := GLMPagerButtonImageState new.! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normal
	^ self pressed: false selected: false! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressed: isPressed
	^ self pressed: isPressed selected: false! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/4/2014 10:53'!
pressed: isPressed selected: isSelected
	^ self pressed: isPressed selected: isSelected checked: false! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/17/2014 12:39'!
pressed: isPressed selected: isSelected checked: isChecked
	"answers sender with image, corresponding specified state"
	
	"pressed has the highest priority"
	(isPressed & self state pressed notNil)
		ifTrue: [ ^ self state pressed ].
	
	(((isPressed & self state pressed isNil) | isSelected) & self state selected notNil)
		ifTrue: [ ^ self state selected ].
		
	(isChecked & self state checked notNil)
		ifTrue: [ ^ self state checked ].
	
	^ self state normal.! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selected: isSelected
	^ self pressed: false selected: isSelected! !

!GLMPagerButtonImageModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
state
	^ state! !

!GLMPagerButtonImageModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
state: anImageState
	state := anImageState.! !

Object subclass: #GLMPagerButtonImageState
	instanceVariableNames: 'normalImage pressedImage selectedImage checkedImage announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerButtonImageState methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMPagerButtonImageState methodsFor: 'getters' stamp: 'AliakseiSyrel 4/4/2014 10:44'!
checked
	^ checkedImage! !

!GLMPagerButtonImageState methodsFor: 'setters-image' stamp: 'AliakseiSyrel 4/4/2014 10:44'!
checked: anImage
	checkedImage := anImage.
	self stateUpdated.! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/4/2014 10:44'!
checkedColor: aColor
	self checked: (self imageFromColor: aColor)! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/4/2014 10:44'!
checkedFromFile: aString
	self checked: (self imageFromFile: aString)! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
imageFromColor: aColor
	^ Morph new color: aColor; imageForm! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
imageFromFile: aString
	^ ImageReadWriter formFromFileNamed: aString.! !

!GLMPagerButtonImageState methodsFor: 'getters' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normal
	^ normalImage! !

!GLMPagerButtonImageState methodsFor: 'setters-image' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normal: anImage
	normalImage := anImage.
	self stateUpdated.! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normalColor: aColor
	self normal: (self imageFromColor: aColor)! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normalFromFile: aString
	self normal: (self imageFromFile: aString)! !

!GLMPagerButtonImageState methodsFor: 'getters' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressed
	^ pressedImage! !

!GLMPagerButtonImageState methodsFor: 'setters-image' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressed: anImage
	pressedImage := anImage.
	self stateUpdated.! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressedColor: aColor
	self pressed: (self imageFromColor: aColor)! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressedFromFile: aString
	self pressed: (self imageFromFile: aString)! !

!GLMPagerButtonImageState methodsFor: 'getters' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selected
	^ selectedImage! !

!GLMPagerButtonImageState methodsFor: 'setters-image' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selected: anImage
	selectedImage := anImage.
	self stateUpdated.! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selectedColor: aColor
	self selected: (self imageFromColor: aColor)! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selectedFromFile: aString
	self selected: (self imageFromFile: aString)! !

!GLMPagerButtonImageState methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
stateUpdated
	self announcer announce: GLMPagerButtonImageUpdated new.! !

Object subclass: #GLMPagerButtonModel
	instanceVariableNames: 'announcer isSelected isPressed isChecked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:42'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
check
	self isChecked ifFalse: [
		isChecked := true.
		self announcer announce: (GLMPagerButtonChecked new).
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
click
	self announcer announce: (GLMPagerButtonClicked new buttonModel: self).! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
depress
	self isPressed ifTrue: [ 
		isPressed := false.
		self announcer announce: (GLMPagerButtonDepressed new).
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:34'!
deselect
	self isSelected ifTrue: [
		isSelected := false.
		self announcer announce: (GLMPagerButtonDeselected new).
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/4/2014 10:45'!
initialize
	super initialize.
	
	isSelected := false.
	isPressed := false.
	isChecked := false.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/4/2014 10:45'!
isChecked
	^ isChecked.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:42'!
isPressed
	^ isPressed.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:42'!
isSelected
	^ isSelected.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/4/2014 11:17'!
on: anObject send: aSymbol to: aReceiver
	self announcer weak
		on: anObject send: aSymbol to: aReceiver.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
press
	self isPressed ifFalse: [
		isPressed := true.
		self announcer announce: (GLMPagerButtonPressed new).
		self click.
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/26/2014 13:57'!
select
	self isSelected ifFalse: [ 
		isSelected := true.
		self announcer announce: (GLMPagerButtonSelected new buttonModel: self).
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
uncheck
	self isChecked ifTrue: [
		isChecked := false.
		self announcer announce: (GLMPagerButtonChecked new).
	]! !

GLMPagerButtonModel subclass: #GLMPagerScrollButtonModel
	instanceVariableNames: 'pageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerScrollButtonModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 11:22'!
pageIndex
	^ pageIndex! !

!GLMPagerScrollButtonModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 11:22'!
pageIndex: anObject
	pageIndex := anObject! !

Object subclass: #GLMPagerModel
	instanceVariableNames: 'numberOfVisiblePages announcer firstVisiblePageIndex pagesCount lastVisiblePageIndex selectedPageIndex focusedMorphs focusedPageIndex virtualFirstVisiblePageIndex virtualLastVisiblePageIndex scrollButtonIconRenderBlock isDependenciesShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 20:29'!
actualNumberOfVisiblePages
	"returns actual number of visible pages based on first and last visible page indexes"

	(firstVisiblePageIndex = lastVisiblePageIndex) & (firstVisiblePageIndex = 0) ifTrue: [ ^ 0 ].
	^ lastVisiblePageIndex - firstVisiblePageIndex + 1.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/3/2014 20:30'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 5/27/2014 23:40'!
assignFocusableMorph: aMorph withPaneAt: paneIndex
	"assigns previosely focused morph with corresponding pane"
	
	focusedMorphs at: paneIndex put: aMorph.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 14:55'!
circleButtonSize
	^ 22! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 13:27'!
convertIndexToValue: anIndex
	
	self size = self actualNumberOfVisiblePages
		ifTrue: [ ^ 0 ]
		ifFalse: [ ^ (anIndex - 1) / (self size - self actualNumberOfVisiblePages ) ]! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 13:27'!
convertValueToIndex: aValue
	
	^ (self size - self actualNumberOfVisiblePages) * aValue + 1.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AndreiChis 4/15/2014 12:18'!
defaultNumberOfVisiblePages
	^ 2! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/27/2014 11:06'!
defaultNumberOfVisiblePages: anInteger
	"use it only when the number of pages is 0"
	self size = 0 ifFalse: [ GLMPagerException signal: 'You can change default number of visible pages only when there is no pages' ].
	numberOfVisiblePages := anInteger.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/29/2014 00:28'!
dependencyButtonSize
	^ self isDependenciesShown ifTrue: [ self circleButtonSize ] ifFalse: [ 0 ].! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 15:10'!
diminishToLeft

	self actualNumberOfVisiblePages = 1 ifTrue: [ ^ self ].
	self virtualLastVisiblePageIndex: (self lastVisiblePageIndex - 1).
	self recomputeState.! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 15:10'!
diminishToRight

	self actualNumberOfVisiblePages = 1 ifTrue: [ ^ self ].
	self virtualFirstVisiblePageIndex: (self firstVisiblePageIndex + 1).
	self recomputeState.! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 15:01'!
enlargeToLeft

	self virtualFirstVisiblePageIndex: (self firstVisiblePageIndex - 1).
	self recomputeState.! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 15:01'!
enlargeToRight

	self virtualLastVisiblePageIndex: (self lastVisiblePageIndex + 1).
	self recomputeState.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 19:34'!
firstVisiblePageIndex
	self invariant.
	^ firstVisiblePageIndex! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 5/27/2014 23:37'!
focusPaneAt: pageIndex
	"tries to focus previosely focused morph at specified pane by its index"
	
	( self isFocusedMorphVisibleAt: pageIndex ) ifTrue: [
		focusedPageIndex := pageIndex.
		(self focusedMorphAt: pageIndex) activeHand newKeyboardFocus: (self focusedMorphAt: pageIndex).
		self notifyFocusedPageChanged.
	].! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 5/27/2014 23:41'!
focusedMorphAt: pageIndex
	"returns previosely focused morph in the pane or nil if no morph was focused"
	
	^ focusedMorphs at: pageIndex ifAbsent: [ nil ]! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 5/27/2014 23:42'!
focusedMorphChanged: aMorph at: pageIndex
	"call this method if a morph was focused in a pane with specified index. As a result corresponding pane will be marked as selected"
	
	focusedPageIndex := pageIndex.
	self assignFocusableMorph: aMorph withPaneAt: pageIndex.
	
	self selectedPageIndex: pageIndex.
	self notifyFocusedPageChanged.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/23/2014 19:26'!
focusedPageIndex
	^ focusedPageIndex! !

!GLMPagerModel methodsFor: 'initialization' stamp: 'AliakseiSyrel 6/29/2014 00:29'!
initialize
	super initialize.

	pagesCount := 0.
	selectedPageIndex := 0.
	focusedMorphs := Dictionary new.
	isDependenciesShown := false.
		
	numberOfVisiblePages := self defaultNumberOfVisiblePages.
	
	firstVisiblePageIndex:= 0.
	lastVisiblePageIndex:= 0.
	
	self invariant.! !

!GLMPagerModel methodsFor: 'invariant' stamp: 'AliakseiSyrel 5/28/2014 01:09'!
invariant
	"If any of these exceptions rise, please notify us through moose-dev mail list. Your help is appreciated"
	
	self isDebug ifFalse: [ ^ self ].
	
	pagesCount >= 0 ifFalse: [ GLMPagerException signal: 'The number of page must be non negative' ].

	pagesCount > 1 ifTrue: [
		firstVisiblePageIndex >= 1 ifFalse: [GLMPagerException signal: 'First visible page index must be > 1 if number of pages > 0'].
		lastVisiblePageIndex >= 1 ifFalse: [GLMPagerException signal: 'Last visible page index must be > 1 if number of pages > 0'].
		lastVisiblePageIndex <= pagesCount ifFalse: [ GLMPagerException signal: 'Last visible page index must be less or equals to the number of pages' ].
		self actualNumberOfVisiblePages <= numberOfVisiblePages ifFalse: [ GLMPagerException signal: 'Actual number of visible pages must be less or equals to current number of visible pages' ].
		selectedPageIndex >= 1 ifFalse: [ GLMPagerException signal: 'Selected page index must be greater or equals then 1 if number of pages is more than 1' ].
	].

	pagesCount = 1 ifTrue: [ 
		firstVisiblePageIndex = 1 ifFalse: [GLMPagerException signal: 'First visible page index must be 1 if number of pages is 1'].
		lastVisiblePageIndex = 1 ifFalse: [GLMPagerException signal: 'Last visible page index must be 1 if number of pages is 1'].
		lastVisiblePageIndex = firstVisiblePageIndex ifFalse: [ GLMPagerException signal: 'First and Last visible page indexes must be equal if number of pages is 1' ].
		self actualNumberOfVisiblePages = 1 ifFalse: [ GLMPagerException signal: 'Actual number of visible pages must be 1 if number of pages is 1' ].
		selectedPageIndex = 1 ifFalse: [ GLMPagerException signal: 'Selected page index must be 1 if number of pages is 1' ].
	].

	pagesCount = 0 ifTrue: [ 
		firstVisiblePageIndex = 0 ifFalse: [GLMPagerException signal: 'First visible page index must be 0 if number of pages is 0'].
		lastVisiblePageIndex = 0 ifFalse: [GLMPagerException signal: 'Last visible page index must be 0 if number of pages is 0'].
		self actualNumberOfVisiblePages = 0 ifFalse: [ GLMPagerException signal: 'Actual number of visible pages must be 0 if there is no pages' ].
		selectedPageIndex = 0 ifFalse: [ GLMPagerException signal: 'Selected page index must be 0 if number of pages is 0' ].
	]! !

!GLMPagerModel methodsFor: 'initialization' stamp: 'AliakseiSyrel 6/25/2014 17:06'!
isDebug
	^ true! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/29/2014 00:28'!
isDependenciesShown
	^ isDependenciesShown! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/29/2014 00:29'!
isDependenciesShown: aBoolean
	isDependenciesShown := aBoolean! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 4/23/2014 20:34'!
isFocusedMorphVisibleAt: paneIndex
	|morph|
	
	morph := self focusedMorphAt: paneIndex.
	morph ifNil: [ ^ false ].
	^ morph isInWorld.! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/28/2014 00:38'!
isPaneVisible: aNumber

	^ (aNumber >= self firstVisiblePageIndex) & (aNumber <= self lastVisiblePageIndex)! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 19:34'!
lastVisiblePageIndex
	| lastIndex |
	self invariant.
	
	lastIndex := self firstVisiblePageIndex + self numberOfVisiblePages - 1.
	^ lastIndex > self size
		ifTrue: [ self size ]
		ifFalse: [ lastIndex ]! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/28/2014 00:37'!
normalizePaneIndex: anIndex
	"retunes normalized pane index. For example: returns 1 if index < 1 and size if index > self size"
	
	anIndex < 1 ifTrue: [ ^ 1 ].
	anIndex > self size ifTrue: [ ^ self size ].
	^ anIndex.! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 4/23/2014 19:32'!
notifyFocusedPageChanged

	self announcer announce: GLMFocusedPageChanged new.! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'TudorGirba 4/15/2014 22:45'!
notifyNumberOfVisiblePagesChanged

	self announcer announce: GLMNumberOfVisiblePagesChanged new.! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'TudorGirba 4/15/2014 22:45'!
notifyPagePoped

	self announcer announce: GLMPagePoped new.! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 5/26/2014 20:16'!
notifyPagePushed: aMorph scrollTo: isScroll smooth: isSmooth
	
	self announcer announce: (GLMPagePushed new morph: aMorph).
	
	isScroll ifTrue: [self scrollToRight: isSmooth ]! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 5/27/2014 13:44'!
notifyScrollPositionChanged: isSmooth

	self announcer announce: (GLMPagerScrollPositionChanged new smooth: isSmooth).! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 5/27/2014 14:07'!
notifyScrollerBoundsChanged: aBounds

	self announcer announce: (GLMPagerBoundsChanged new bounds: aBounds).! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 4/23/2014 19:23'!
notifySelectedPageChanged

	self announcer announce: GLMSelectedPageChanged new.! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 5/27/2014 14:26'!
notifySynchronizeScrollTo: aValue 
	
	self announcer announce: (GLMPagerSynchronizeScrollAnnouncement new value: aValue).! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 10:37'!
numberOfVisiblePages
	^ numberOfVisiblePages! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 23:50'!
popAndReplacePane: aMorph
	
	self popPane.
	self pushPane: aMorph smooth: false.! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 23:55'!
popPane

	self invariant.
	
	pagesCount >= 1 ifTrue: [
		|scrollTo|
		
		focusedMorphs removeKey: pagesCount  ifAbsent: [ true ].
		pagesCount := pagesCount - 1.
		
		lastVisiblePageIndex > pagesCount ifTrue: [
			firstVisiblePageIndex := firstVisiblePageIndex - 1.
			lastVisiblePageIndex := lastVisiblePageIndex - 1.
		].
	
		firstVisiblePageIndex < 1 ifTrue: [
			firstVisiblePageIndex := 1.
		].
	
		pagesCount = 0 ifTrue: [
			selectedPageIndex := 0.
		].
		
		scrollTo := ((pagesCount = self firstVisiblePageIndex) & (pagesCount > self numberOfVisiblePages)).
		self notifyPagePoped.
	].

	self invariant.! !

!GLMPagerModel methodsFor: 'private' stamp: 'AliakseiSyrel 5/27/2014 14:15'!
privateRecomputeIndexesAfterScrollAt: aFloat
	"while rounding fractional part < 0.5"
	|left right|
	
	self invariant.
	
	left := self convertValueToIndex: aFloat.
	right := left + self actualNumberOfVisiblePages - 1.
	firstVisiblePageIndex := left rounded.
	lastVisiblePageIndex := right rounded.
	
	lastVisiblePageIndex > self size ifTrue: [
		|delta|
		delta := lastVisiblePageIndex - self size.
		firstVisiblePageIndex := firstVisiblePageIndex - delta.
		lastVisiblePageIndex := lastVisiblePageIndex - delta.
	].
		
	self invariant.
	
	! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/28/2014 00:22'!
pushPane: aMorph smooth: aBoolean

	self invariant.
	
	pagesCount := pagesCount + 1.
	
	self size = 1
		ifTrue: [ 
			firstVisiblePageIndex := 1.
			lastVisiblePageIndex := 1.
			selectedPageIndex := 1.
		]
		ifFalse: [ 
			(self actualNumberOfVisiblePages < self numberOfVisiblePages) ifTrue: [
				lastVisiblePageIndex := lastVisiblePageIndex + 1.
			].
		].
	
	self notifyPagePushed: aMorph scrollTo: true smooth: aBoolean.
	self size = 1 ifTrue: [ self notifySelectedPageChanged ].
	
	self invariant.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/28/2014 00:56'!
recomputeState
	"recomputes current model state and if necessary notifies all listeners about changes"
	|tmpNumberOfVisiblePages notifyNumberOfVisiblePagesChanged|
	
	notifyNumberOfVisiblePagesChanged := false.
	
	self invariant.
	
	((virtualFirstVisiblePageIndex isNil) & (virtualLastVisiblePageIndex isNil)) ifTrue: [ ^ self ].
	virtualFirstVisiblePageIndex ifNil: [ virtualFirstVisiblePageIndex := self firstVisiblePageIndex ].
	virtualLastVisiblePageIndex ifNil: [ virtualLastVisiblePageIndex := self lastVisiblePageIndex ].
	
	tmpNumberOfVisiblePages := virtualLastVisiblePageIndex - virtualFirstVisiblePageIndex + 1.
	tmpNumberOfVisiblePages = numberOfVisiblePages ifFalse: [ notifyNumberOfVisiblePagesChanged := true ].
	numberOfVisiblePages := tmpNumberOfVisiblePages.
	
	firstVisiblePageIndex := virtualFirstVisiblePageIndex.
	lastVisiblePageIndex := virtualLastVisiblePageIndex.

	self invariant.
	
	virtualFirstVisiblePageIndex = nil.
	virtualLastVisiblePageIndex = nil.
	
	notifyNumberOfVisiblePagesChanged ifTrue: [ self notifyNumberOfVisiblePagesChanged ].
	self notifyScrollPositionChanged: true.
	! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/28/2014 22:05'!
scrollButtonIconRenderBlock
	^ scrollButtonIconRenderBlock! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/28/2014 22:05'!
scrollButtonIconRenderBlock: anObject
	scrollButtonIconRenderBlock := anObject! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 14:06'!
scrollTo: aFloat smooth: isSmooth
	"notifies all listeners to scroll at the specified value"
	
	self privateRecomputeIndexesAfterScrollAt: aFloat.
	self notifyScrollPositionChanged: isSmooth.! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/28/2014 00:18'!
scrollToPane: pageIndex
	"scrolls to specified pane specified by its index"

	self scrollTo: (self convertIndexToValue: pageIndex) smooth: true.
	! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/26/2014 20:18'!
scrollToRight: isSmooth
	"notifies all listeners that it is time to scroll most right"

	self scrollTo: 1.0 smooth: isSmooth! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/28/2014 00:38'!
selectToLeft
	"moves focus to left"
	
	self selectedPageIndex: (self selectedPageIndex - 1).! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/28/2014 00:34'!
selectToRight
	"moves focus to right"
	
	self selectedPageIndex: (self selectedPageIndex + 1).! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/23/2014 19:16'!
selectedPageIndex
	^ selectedPageIndex! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/28/2014 00:39'!
selectedPageIndex: anIndex
	"changes current selected page and scrolls to it if necessary. Also if possible re-focused available morph"
	
	self invariant.
	
	anIndex := self normalizePaneIndex: anIndex.
	
	(self isPaneVisible: anIndex) ifFalse: [
		"we need to scroll if new selected page is invisible"
		self scrollToPane: (anIndex < self firstVisiblePageIndex ifTrue: [ anIndex ] ifFalse: [(anIndex - self numberOfVisiblePages + 1)]).
	].
	
	selectedPageIndex := anIndex.
	self focusPaneAt: anIndex.
	self notifySelectedPageChanged.

	self invariant.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 19:29'!
size
	^ pagesCount.! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/28/2014 00:39'!
switchPaneTo: anIndex
	"switches pane to specified. Works as scrollToPane, but additionaly selects and focuses that pane."
	
	self invariant.
	
	anIndex := self normalizePaneIndex: anIndex.
	
	self scrollToPane: anIndex.	
	self focusPaneAt: anIndex.
	
	selectedPageIndex := anIndex.
	self notifySelectedPageChanged.
	
	self invariant.! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 14:29'!
synchronizeScrollTo: aValue
	
	self notifySynchronizeScrollTo: aValue.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/26/2014 13:50'!
updatePreview: anIndex

	self announcer announce: (GLMPagerPreviewUpdate new pageIndex: anIndex )! !

!GLMPagerModel methodsFor: 'private' stamp: 'AliakseiSyrel 5/26/2014 17:58'!
virtualFirstVisiblePageIndex
	^ virtualFirstVisiblePageIndex! !

!GLMPagerModel methodsFor: 'private' stamp: 'AndreiChis 6/28/2014 21:11'!
virtualFirstVisiblePageIndex: anIndex

	virtualFirstVisiblePageIndex := self normalizePaneIndex: anIndex.
	! !

!GLMPagerModel methodsFor: 'private' stamp: 'AliakseiSyrel 5/28/2014 00:57'!
virtualLastVisiblePageIndex

	^ virtualLastVisiblePageIndex! !

!GLMPagerModel methodsFor: 'private' stamp: 'AndreiChis 6/28/2014 21:11'!
virtualLastVisiblePageIndex: anIndex.

	virtualLastVisiblePageIndex := self normalizePaneIndex: anIndex.! !

Object subclass: #GLMPagerWidgetThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerWidgetThemer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 6/28/2014 22:18'!
defaultScrollButtonStyleFor: aButton

	aButton checkedIcon: GLMUIThemeExtraIcons glamorousGrayCircleEmpty.
	aButton checkedFocusedIcon: GLMUIThemeExtraIcons glamorousGrayCircle.
	
	aButton image state normal: GLMUIThemeExtraIcons glamorousGrayCircleEmpty.
	aButton image state selected: GLMUIThemeExtraIcons glamorousGrayCircle.
	aButton image state checked: aButton checkedIcon.! !

!GLMPagerWidgetThemer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/26/2014 14:43'!
previewPaneStyleFor: aMorph

	aMorph borderColor: (Color lightGray)! !

!GLMPagerWidgetThemer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/28/2014 00:43'!
selectedPaneStyleFor: aMorph

	aMorph borderColor: (Color transparent)! !

GLMMorphicFinderRenderer subclass: #GLMMorphicPagerRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Glamour'!

!GLMMorphicPagerRenderer commentStamp: 'AndreiChis 6/28/2014 21:19' prior: 0!
A GLMMorphicPagerRenderer is xxxxxxxxx.
!

!GLMMorphicPagerRenderer methodsFor: 'callbacks' stamp: 'AliakseiSyrel 6/27/2014 13:40'!
actOnPaneAdded: ann
	container pushPane: (self renderObject: ann pane).! !

!GLMMorphicPagerRenderer methodsFor: 'callbacks' stamp: 'AliakseiSyrel 4/5/2014 13:50'!
actOnPaneRemoved: ann
	container popPane! !

!GLMMorphicPagerRenderer methodsFor: 'callbacks' stamp: 'AliakseiSyrel 4/5/2014 13:54'!
actOnPaneReplaced: ann
	container popAndReplacePane: (self renderObject: ann newPane)! !

!GLMMorphicPagerRenderer methodsFor: 'accessing' stamp: 'AndreiChis 6/28/2014 21:18'!
defaultScrollButtonIconRenderBlock

	^ [ :object | {Form new. Form new} ]! !

!GLMMorphicPagerRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 6/29/2014 00:41'!
render: aBrowser
	|adapter|
	adapter := GLMPagerModel new
		isDependenciesShown: false.
	
	aBrowser scrollButtonIconRenderBlock ifNotNil: [
		"result value of the block is raw icon of the Form class"
		adapter scrollButtonIconRenderBlock: [ :index | aBrowser scrollButtonIconRenderBlock cull: ((aBrowser panes at: index) port: #entity) value ]
	].
	
	container := GLMPagerMorph new
		name: 'scroller';
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		adapter: adapter;
		beTransparent;
		yourself.

	"container maxPanes: aBrowser fixedSizePanes."
	self registerAnnouncementsFor: aBrowser.  
	aBrowser panes
		do: [ :each | container pushPane: (self renderObject: each) ].
	^ container! !
